const { createElement, render, useState,useEffect,Fragment} = wp.element;
const {select,dispatch}=wp.data;

const Popup = (props) => {
	const [applyPopup,setApplyPopup] = useState(false);
	const [isLoading,setisLoading] = useState(false);
	const [message,setMessage] = useState('');
	const token = select('vibebp').getToken();
	useEffect(()=>{
		
		setApplyPopup(true);
        
	},[props]);

	const applyForCourse = () => {
			
			setisLoading(true);
			fetch(`${window.wplms_course_data.api_url}/mycred/assigncourse?post`,{
				method: 'post',
			    body: JSON.stringify({
			    	id:props.id,
			        token:token
			    }),
			}).then(res => res.json())
	        .then((res) => {
	           	if(res.status){
	           		setApplyPopup(false);
	           		
	           		var postevent = new CustomEvent('reload_course_button', { "detail":{course:props.id}});
        			document.dispatchEvent(postevent);
	           	}else{
	           		if(res.hasOwnProperty('message') && res.message.length){
	           			setMessage(res.message);
	           		}
	           	}
	           	setisLoading(false);
	        });
	        
	};

	let style = {};
	if(isLoading){
		style= {
			"opacity":'0.5',
			"pointer-events":'none'
		}
	}

	return (
		<Fragment>
		

		{
			(applyPopup)?
			<div className="popup_wrapper" onClick={(event)=>{event.preventDefault();

			   	if(document.querySelector('.popup_wrapper') && event.target === document.querySelector('.popup_wrapper')) {
			      setApplyPopup(false);
			  	}
			 }}>
			<div className="popup_content">
				<span className="vicon vicon-close" onClick={()=>{setApplyPopup(false)}}></span>
				<h3>{window.vibe_mycred.translations.buy_with_points}</h3>

				{
					(message.length)?
					<div className="vbp_message error message">{message}</div>
					:''
				}

				<div className="popup-footer">
				<a className="button is-primary" style={style} onClick={applyForCourse}>{window.wplms_course_data.translations.yes}</a>

				<a className="button is-primary" onClick={()=>{setApplyPopup(false)}}>{window.wplms_course_data.translations.cancel}</a>

				</div>
			</div>
			</div>
			:''
		}
		</Fragment>
	);
}

export default Popup;
