const { createElement, useState, useEffect, Fragment, render} = wp.element;
const { dispatch, select } = wp.data;

import Logs from './logs';
const Mycred = (props) => {


	const [isLoading,setLoading] = useState(false);


	const [courseFilters,setCourseFilters] = useState([]);
	const [args,setArgs] = useState([]);
	const [activeTab,setActiveTab] = useState('logs');
	const [newCourse,setNewCourse] = useState(false);

	useEffect(()=>{
		let course_filters = select('vibebp').getMenu().filter((item)=>{return item.parent === 'points'});
		course_filters.map((filter,index)=>{
			if(course_filters.findIndex((item)=>{return item.class.indexOf('current-menu-item') > -1}) === -1){
				course_filters[index].class.push('current-menu-item');
			}
		});

		setCourseFilters(course_filters);
		if(document.querySelector('body').classList.value.indexOf('withsidebar') == -1){
			document.querySelector('body').classList.add('withsidebar');
		}

	},[]);


	return (
		<div className="vibebp_sidebars">
			<div className="vibebp_left_sidebar_wrapper">
				<div className="vibebp_left_sidebar">
					<h3>{window.vibe_mycred.translations.points}</h3>
					{
						courseFilters.map((filter,i)=>{
							let classs = filter.class.join(' ')+' '+filter.css_id;
						
							return (
								<a className={classs} onClick={(e)=>{
									let nargs = {...args}; 

									nargs.filter=filter.css_id; 
									nargs.page = 1;

									if(args.css_id !== nargs.filter){
										setArgs(nargs);
									}

									setActiveTab(filter.css_id);
									let ffilters = [...courseFilters];

									let index = ffilters.findIndex((item)=>{return item.class.indexOf('current-menu-item') > -1});
									ffilters[index].class.splice(ffilters[index].class.indexOf('current-menu-item'),1);
									ffilters[i].class.push('current-menu-item');
									setCourseFilters(ffilters);
								}}
								>{filter.name}</a>
							)
						})
					}
				</div>
			</div>
			<div className="vibebp_main">
				{
					(activeTab === 'logs')?
					<div id="logs_content"><Logs type='logs'/></div>
					
					:''
					
				}
			</div>
		</div>
	)
	
}

export default Mycred;


