const { createElement, useState, useEffect, Fragment, render,useContext,useRef} = wp.element;
const { dispatch, select } = wp.data;
import Loading from './../../components/loading';

const Commissions = (props) => {
	let user = select( 'vibebp' ).getUser();
    let token = select('vibebp').getToken();
	const [isLoading,setisLoading] = useState(true);
	const [records,setrecords] = useState([]);
    const [args,setArgs] = useState({paged:1});
    const [balance,setBalance] = useState(null);

    const [loadMore,setloadMore] = useState(true);
	
	useEffect(()=>{
        loadRecords();
	},[args]);

    useEffect(()=>{
        document.addEventListener('vibebp_component_reload',loadRecords);
        return ()=>{ document.removeEventListener('vibebp_component_reload',loadRecords)}
    },[]);

    const loadRecords = () => {
        setisLoading(true);    
        fetch(`${window.vibe_mycred.api_url}/logs?paged=${args.paged}`,{
            method:'post',
            body:JSON.stringify({token:token,'paged':args.paged})
        }).then((res)=>res.json())
        .then((data)=>{
            
            if(data && data.status){
                let nrecords = [...records];
                if(args.paged==1){
                    nrecords = [];
                }
                if(data.entries.length){
                    for (var i = 0; i <data.entries.length; i++) {
                        nrecords.push(data.entries[i]);
                    }
                    setrecords(nrecords);
                }
                if(data.entries.length < window.vibe_mycred.per_page){
                    setloadMore(false);
                }
            }else{
                 setloadMore(false);
            }
            if(data.hasOwnProperty('balance')){setBalance(data.balance)}
            setisLoading(false);
        });
    }

	return (
        <div>
            {
                (balance!==null)?
                <div className="columns">
             
                    <span>
                        
                        <span className="vicon vicon-star"></span> <span className="title" style={{'color':'inherit'}}>{balance}</span>
                    </span>
                  
                </div>
                :''
            }
            
            <div className="points_records">
            {
                (records.length)?
                <Fragment>
                <table className="table">
                    <thead>
                        <th>{window.vibe_mycred.translations.entry}</th>
                        <th>{window.vibe_mycred.translations.date}</th>
                        <th>{window.vibe_mycred.translations.points_label}</th>
                    </thead>
                    <tbody >
                    {
                        records.map((rec)=>{
                            return <tr dangerouslySetInnerHTML={{__html:rec}}></tr>
                        })
                    }
                    </tbody>
                </table>
                {
                    (loadMore && !isLoading)?
                    <a className="link" onClick={()=>{setArgs({...args,'paged':args.paged+1})}}>{window.vibe_mycred.translations.load_more}</a>
                    :''
                }
                </Fragment>
                :(!isLoading)?<div className="vbp_message error message">{window.vibe_mycred.translations.no_records}</div>:''
            }
            </div>
            {
                (isLoading)?
                    <Loading />
                :''
            }
        </div>
    );
}

export default Commissions;

